--[[--------------------------------------------------------------------------------
  ItemSync Framework

  Author:  Derkyle
  Website: http://www.manaflux.com
-----------------------------------------------------------------------------------]]

--create the global method table
ISync =  {};
ISyncVarLoad 	= 0;

--Global
ISYNC_VERSION = 10.6;

--declares local
local ISyncPEnterLoad 	= 0;
local ISync_Cost	= 0;

--hook
local ISync_HookedMoney;
local ISync_HookedOnShow;

--declare globals
ISync_RealmNum	= 0;
ISync_LoadOnce =  0;

---------------------------------------------------
-- ISync:OnLoad
---------------------------------------------------
function ISync:OnLoad()

	--create database and options variable if missing
	if( not ISyncDB ) then ISyncDB = { }; end
	if( not ISyncOpt ) then ISyncOpt = { }; end

	--display loaded
	if( DEFAULT_CHAT_FRAME ) then
		DEFAULT_CHAT_FRAME:AddMessage("|c00A2D96FDerkyle's ItemSync Ver. ["..ISYNC_VERSION.."]|r  |cffffffffType: /itemsync  /isync  /ims  /is");
	end
	
	
	--hook the new money tooltip function since patch 1.7
	--this is the new way to grab prices
	ISync_HookedMoney = GameTooltip:GetScript("OnTooltipAddMoney");
	GameTooltip:SetScript("OnTooltipAddMoney", ISync.AddMoney);
	
	
	ISync_HookedOnShow = GameTooltip:GetScript("OnShow");
	GameTooltip:SetScript("OnShow", ISync.OnTooltipShow);


	-- Register our slash command
	---------------------------------------------------
	SLASH_ITEMSYNC1 = "/itemsync";
	SLASH_ITEMSYNC2 = "/isync";
	SLASH_ITEMSYNC3 = "/ims";
	SLASH_ITEMSYNC4 = "/is";
	SlashCmdList["ITEMSYNC"] = ISync_SlashCommand;

	
	--this is for AxuItemMenus :) Thanks Axu!
	if (AxuItemMenus_AddConfigToggle) then

		AxuItemMenus_AddConfigToggle({
		id = "isync", -- this appears in my previous snippet
		default = true, -- feature enabled by default
		-- consider localizing the following:
		text = "ItemSync",
		helptext = "Enable pop-up menus in ItemSync"
		});
	end



	--add our frames to the special frames, this way when a user press's escape it will
	--close the window
	tinsert(UISpecialFrames, "ISync_MainFrame");
	
end

---------------------------------------------------
-- ISync:SlashCommand
---------------------------------------------------
function ISync_SlashCommand(msg)


	if (msg == nil) then 
	
		if(ISyncVarLoad == 1) then


			if ( ISync_MainFrame:IsVisible() ) then 
				ISync_MainFrame:Hide();
			else
				ISync_MainFrame:Show();
			end


		end
		
		return nil;
		
	end
	
	
	local num, offset, command, args = string.find (msg, "^(%w+)%s*(.*)$");
	

	if (command == nil) then 

		if(ISyncVarLoad == 1) then


			if ( ISync_MainFrame:IsVisible() ) then 
				ISync_MainFrame:Hide();
			else
				ISync_MainFrame:Show();
			end


		end

	--the user is preforming a search
	elseif string.lower(command) == "search" and args ~= nil or args ~= "" then

		
		if(ISync.SF_Reset and ISync_TextEditBox and ISyncVarLoad == 1 ) then
			
			
			--reset first
			ISync:SF_Reset();
			
				ISync_TextEditBox:SetText(args);
				
				ISYNC_SHOWSEARCH_CHK = 1;
				ISync:Main_Refresh();

				--only show if it's hidden
				if ( not ISync_MainFrame:IsVisible() ) then 
				
					ISync_MainFrame:Show();
				end
			
				
		end
		

	--the user is preforming a search (with just s instead of search)
	elseif string.lower(command) == "s" and args ~= nil or args ~= "" then

		
		if(ISync.SF_Reset and ISync_TextEditBox and ISyncVarLoad == 1 ) then
			
			
			--reset first
			ISync:SF_Reset();
			
				ISync_TextEditBox:SetText(args);
				
				ISYNC_SHOWSEARCH_CHK = 1;
				ISync:Main_Refresh();

				--only show if it's hidden
				if ( not ISync_MainFrame:IsVisible() ) then 
				
					ISync_MainFrame:Show();
				end
			
				
		end
		
		
	--the user is preforming a search
	elseif string.lower(command) == "itemid" then
	
	    if ISync_ItemIDFrame:IsVisible() then
		HideUIPanel(ISync_ItemIDFrame);
	    else
		ShowUIPanel(ISync_ItemIDFrame);
	    end
	
	
	
	--the user is preforming a search
	elseif string.lower(command) == "help" then
	
		if( DEFAULT_CHAT_FRAME ) then
			DEFAULT_CHAT_FRAME:AddMessage("|c00FFFF00ItemSync Ver. ["..ISYNC_VERSION.."]|r");
			DEFAULT_CHAT_FRAME:AddMessage("|c00FFFF00/itemsync, /isync, /ims, /is, /bagview, /bv, /bagv|r");
			DEFAULT_CHAT_FRAME:AddMessage("|c00FFFF00 |r");
			DEFAULT_CHAT_FRAME:AddMessage("|c00FFFF00ItemSync "..ISYNC_BT_SEARCH..":   /is search itemname|r");
			DEFAULT_CHAT_FRAME:AddMessage("|c00FFFF00ItemSync "..ISYNC_BT_ITEMID..":   /is itemid|r");
		end
	    
		
	else
	
		if(ISyncVarLoad == 1) then


			if ( ISync_MainFrame:IsVisible() ) then 
				ISync_MainFrame:Hide();
			else
				ISync_MainFrame:Show();
			end


		end
		
	end
	
	

end



---------------------------------------------------
-- ISync:OnEvent
---------------------------------------------------
function ISync:OnEvent(event)


	if( event == "VARIABLES_LOADED" ) then

		--just in case
		if( not ISyncDB ) then ISyncDB = { }; end
		if( not ISyncOpt ) then ISyncOpt = { }; end
		
		--add realm to list if not already
		ISync_RealmNum = ISyncCore_AddRealm();
		
		--check realm
		if(ISync_RealmNum and not ISyncDB[ISync_RealmNum] ) then ISyncDB[ISync_RealmNum] = { }; end
		
		--toggle to on
		ISyncVarLoad = 1;
	
		--Set to Default
		GameTooltip.isDisplayDone = nil;
		
	    	--check for variables loaded
		if(ISyncVarLoad == 1) then

			--create the options if it doesn't exsist
			if(not ISyncOpt) then ISyncOpt = { }; end
			
				--check for options
				if (not ISyncOpt.PRICE) then ISyncOpt.PRICE = 1; end
				if (not ISyncOpt.VENDOR) then ISyncOpt.VENDOR = 1; end
				if (not ISyncOpt.MONEYSET) then ISyncOpt.MONEYSET = 1; end
				if( not ISyncOpt.GOLD) then ISyncOpt.GOLD = "|c00FFFFFF%s|r|c00E2CD54"..ISYNC_OPTGOLD1.."|r "; end
				if( not ISyncOpt.SILVER) then ISyncOpt.SILVER = "|c00FFFFFF%s|r|c00AEAEAE"..ISYNC_OPTSILVER1.."|r "; end
				if( not ISyncOpt.COPPER) then ISyncOpt.COPPER = "|c00FFFFFF%s|r|c00D7844D"..ISYNC_OPTCOPPER1.."|r"; end
				if( not ISyncOpt.Realms) then ISyncOpt.Realms = { }; end
				if( not ISyncOpt.RealmCount) then ISyncOpt.RealmCount = 0; end
				if( not ISyncOpt.ItemDisplay) then ISyncOpt.ItemDisplay = 0; end
				if( not ISyncOpt.RarityDD) then ISyncOpt.RarityDD = "name"; end
				if( not ISyncOpt.ShowMoneyIcons) then ISyncOpt.ShowMoneyIcons = 0; end
				if( not ISyncOpt.ALERT_Quality) then ISyncOpt.ALERT_Quality = 1; end
				if( not ISyncOpt.ALERT_Invalid) then ISyncOpt.ALERT_Invalid = 1; end
				
				--numbers to store
				if( not ISyncOpt.ItemCount_Valid) then ISyncOpt.ItemCount_Valid = 0; end
				if( not ISyncOpt.ItemCount_InValid) then ISyncOpt.ItemCount_InValid = 0; end
				
				--check on mods
				if( not ISyncOpt.MOD_AuctionMatrix) then ISyncOpt.MOD_AuctionMatrix = 1; end
				if( not ISyncOpt.MOD_Auctioneer) then ISyncOpt.MOD_Auctioneer = 1; end
				if( not ISyncOpt.MOD_ReagentInfo) then ISyncOpt.MOD_ReagentInfo = 1; end
				if( not ISyncOpt.MOD_AIOI) then ISyncOpt.MOD_AIOI = 1; end
				if( not ISyncOpt.MOD_MyInventory) then ISyncOpt.MOD_MyInventory = 1; end
				
				--server options
				if( not ISyncOpt.SERVER_MergeDB) then ISyncOpt.SERVER_MergeDB = 0; end
				
				
				--minimap button
				if( not ISyncOpt.MiniMapButton_Show) then ISyncOpt.MiniMapButton_Show = 1; end
				if( not ISyncOpt.MiniMapButton_Loc) then ISyncOpt.MiniMapButton_Loc = 305; end
				
				
				--clean options
				if( not ISyncOpt.CLEAN_ShowItemIcon) then ISyncOpt.CLEAN_ShowItemIcon = 1; end
				
				--general options
				if( not ISyncOpt.GENERAL_EnableTypeLinks) then ISyncOpt.GENERAL_EnableTypeLinks = 0; end
				
				--filters
				if (not ISyncOpt.Filters) then ISyncOpt.Filters = { }; end
				if (not ISyncOpt.Filters[0]) then ISyncOpt.Filters[0] = 1; end
				if (not ISyncOpt.Filters[1]) then ISyncOpt.Filters[1] = 1; end
				if (not ISyncOpt.Filters[2]) then ISyncOpt.Filters[2] = 1; end
				if (not ISyncOpt.Filters[3]) then ISyncOpt.Filters[3] = 1; end
				if (not ISyncOpt.Filters[4]) then ISyncOpt.Filters[4] = 1; end
				if (not ISyncOpt.Filters[5]) then ISyncOpt.Filters[5] = 1; end
				if (not ISyncOpt.Filters[99]) then ISyncOpt.Filters[99] = 1; end
				--colors (these are default which can be updated)
				if (not ISyncOpt.Colors) then ISyncOpt.Colors = { }; end
				if (not ISyncOpt.Colors[0]) then ISyncOpt.Colors[0] = "ff9d9d9d"; end
				if (not ISyncOpt.Colors[1]) then ISyncOpt.Colors[1] = "ffffffff"; end
				if (not ISyncOpt.Colors[2]) then ISyncOpt.Colors[2] = "ff1eff00"; end
				if (not ISyncOpt.Colors[3]) then ISyncOpt.Colors[3] = "ff0070dd"; end
				if (not ISyncOpt.Colors[4]) then ISyncOpt.Colors[4] = "ffa335ee"; end
				if (not ISyncOpt.Colors[5]) then ISyncOpt.Colors[5] = "ffff8000"; end
				if (not ISyncOpt.Colors[-1]) then ISyncOpt.Colors[-1] = "ff9d9d9d"; end
				if (not ISyncOpt.Colors["ff9d9d9d"]) then ISyncOpt.Colors["ff9d9d9d"] = 0; end
				if (not ISyncOpt.Colors["ffffffff"]) then ISyncOpt.Colors["ffffffff"] = 1; end
				if (not ISyncOpt.Colors["ff1eff00"]) then ISyncOpt.Colors["ff1eff00"] = 2; end
				if (not ISyncOpt.Colors["ff0070dd"]) then ISyncOpt.Colors["ff0070dd"] = 3; end
				if (not ISyncOpt.Colors["ffa335ee"]) then ISyncOpt.Colors["ffa335ee"] = 4; end
				if (not ISyncOpt.Colors["ffff8000"]) then ISyncOpt.Colors["ffff8000"] = 5; end
				if (not ISyncOpt.Colors["ff9d9d9d"]) then ISyncOpt.Colors["ff9d9d9d"] = -1; end

				--version
				if (not ISyncOpt.Version) then ISyncOpt.Version = ISYNC_VERSION; end
				
				
				--this is for the update from previous versions to the newest data format
				--of version 5
				if (ISyncOpt.Version and tonumber(ISyncOpt.Version) < 5) then
				
					ISyncOpt.Version = ISYNC_VERSION;
					
					--empty database
					ISyncDB = nil;
					ISyncDB_Invalid = nil;

					--recreate database
					if( not ISyncDB ) then ISyncDB = { }; end
		
					--check realm name
					if(not ISync_RealmNum) then ISync_RealmNum = ISyncCore_AddRealm(); end

					--check realm
					if(ISync_RealmNum and not ISyncDB[ISync_RealmNum] ) then ISyncDB[ISync_RealmNum] = { }; end

					DEFAULT_CHAT_FRAME:AddMessage("|c00A2D96FItemSync: "..ISYNC_OLDDBDELETED..".|r");
					
					--clean the database
					ISync:CleanDatabase();
				
				--update for version 9
				elseif (ISyncOpt.Version and tonumber(ISyncOpt.Version) < 9) then
				
					ISyncOpt.Version = ISYNC_VERSION;
					
					--empty invalid database
					ISyncDB_Invalid = nil;
					
					--do it again just in case
					ISync:CleanDatabase();
					
					--AND AGAIN JUST IN CASE
					ISync:CleanDatabase();

					--the cleaning of the database should have updated the db for us
					DEFAULT_CHAT_FRAME:AddMessage("|c00A2D96FItemSync: Database Update.|r");
					
					DEFAULT_CHAT_FRAME:AddMessage("|c00A2D96FItemSync: It is recommended that you clean the database a few times.  The ability is under the filters panel.|r");
					
					--clean the database
					ISync:CleanDatabase();
					
				--else update it to latest one
				elseif (ISyncOpt.Version and ISyncOpt.Version ~= ISYNC_VERSION) then 
				
					--for some reason the version didn't save so lets save it
					ISyncOpt.Version = ISYNC_VERSION;
					
					--clean the database
					ISync:CleanDatabase();
				
				end
				
				
				
				
			--alter the gui using localization
			if(ISync_AlterGUI) then ISync_AlterGUI(); end
			
			
			--do the minimap button stuff
			if(ISync.MiniMapButton_Init and ISync.MiniMapButton_UpdatePosition) then
			
				ISync:MiniMapButton_Init();
				ISync:MiniMapButton_UpdatePosition();
				
			end
			
		
		end
		
	--check inspecting
	elseif( event == "PLAYER_TARGET_CHANGED" ) then

		if(ISyncVarLoad == 1) then

			--inspect only if it's not the current player and the target is a player
			if(not UnitIsUnit("target", "player") and UnitIsPlayer("target") ) then 
				ISync:InspectTarget("target"); 
			end

		end

	--the inventory has been updated so lets check it again
	elseif( event == "UNIT_INVENTORY_CHANGED" ) then

		if(ISyncVarLoad == 1 and arg1 == "player" ) then 
		
			--the reason we use a timer is because for some reason times the UNIT_INVENTORY_CHANGED
			--is sent by blizzard like a million times.  This way each time it's passed
			--it will reset the timer to .2 seconds until the last UNIT_INVENTORY_CHANGED is sent.  When
			--that happens the UNIT_INVENTORY_CHANGED procedure will fire once the timer is complete.
			if(ISyncVarLoad == 1) then ISync_CoreFrame.unitinvchanged = .2; end
		
		end
		

	--bank frame opened so lets scan that too
	elseif( event == "BANKFRAME_OPENED" ) then

		if(ISyncVarLoad == 1) then ISync:ScanBank(); end

	--scan auction window
	elseif( event == "AUCTION_ITEM_LIST_UPDATE" ) then

		if(ISyncVarLoad == 1) then ISync:ScanAuction(); end

	--scan merchant window
	elseif( event == "MERCHANT_SHOW" ) then
        	
		if(ISyncVarLoad == 1) then ISync:MerchantMoneyScan(this); end
		if(ISyncVarLoad == 1) then ISync:VendorScan(); end
		if(ISyncVarLoad == 1) then ISync:BV_Refresh(); end --update bagview
		

	--scan tooltip money
	elseif( event == "BAG_UPDATE" ) then
	
		--the reason we use a timer is because for some reason times the bagupdate
		--is sent by blizzard like a million times.  This way each time it's passed
		--it will reset the timer to .2 seconds until the last bagupdate is sent.  When
		--that happens the bagupdate procedure will fire once the timer is complete.
		if(ISyncVarLoad == 1) then ISync_CoreFrame.bagupdate = .2; end
		
	
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
	
		if(ISync_LoadOnce == 0) then
		
			ISync:InspectTarget("player");
			ISync:ScanInv();
			
			--update the display frame if shown
			if(ISyncOpt and ISyncOpt.ItemDisplay and ISync.ItemDisplay_Update) then
				ISync:ItemDisplay_Update();
			end
		
			ISync_LoadOnce = 1;
			
			--DEFAULT_CHAT_FRAME:AddMessage("1st check loaded");
		end
			

		ISyncPEnterLoad = 1; --toggle
		
	--check addon load
	elseif( event == "ADDON_LOADED") then
	

	--this is usually chat messages that get processed
	else 
		if(ISyncVarLoad == 1) then ISync:ProcessLinks(arg1, "CHAT", nil, nil); end

	end

end


---------------------------------------------------
-- ISync:OnUpdateTriggered
---------------------------------------------------
function ISync:OnUpdateTriggered(elapsed)

	--BAG_UPDATE
	if(ISync_CoreFrame.bagupdate) then
	
		--update the laspe
		ISync_CoreFrame.bagupdate = ISync_CoreFrame.bagupdate - elapsed;
		
		--check if the timer ran out
		if ( ISync_CoreFrame.bagupdate <= 0 ) then
			
			ISync:BV_Refresh();
			ISync_CoreFrame.bagupdate = nil;
			
		
		end

	end
	
	
	--UNIT_INVENTORY_CHANGED
	if(ISync_CoreFrame.unitinvchanged) then
	
		--update the laspe
		ISync_CoreFrame.unitinvchanged = ISync_CoreFrame.unitinvchanged - elapsed;
		
		--check if the timer ran out
		if ( ISync_CoreFrame.unitinvchanged <= 0 ) then
			
			--inspect user and inventory
			ISync:InspectTarget("player");
			ISync:ScanInv();
			
			--update bagview
			ISync:BV_Refresh();
			
			ISync_CoreFrame.unitinvchanged = nil;
			
		
		end

	end
	

	

end


---------------------------------------------------
-- ISync:Binding
---------------------------------------------------
function ISync:Binding()


	if(ISyncVarLoad == 1) then
	

		if ( ISync_MainFrame:IsVisible() ) then 
			ISync_MainFrame:Hide();
		else
			ISync_MainFrame:Show();
		end
	

	end

	
end



--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------


---------------------------------------------------
-- ISync:ProcessLinks
---------------------------------------------------
function ISync:ProcessLinks(sText, sEvent, sVendorPrice, sVendorQty)

	--check for information first
	if(not sText) then return nil; end

	local item, name, color, sParseLink;
	
	--check for database
	if( not ISyncDB ) then ISyncDB = { }; end
	if( not ISync_RealmNum) then ISync_RealmNum = ISyncCore_AddRealm(); end;
	if( ISync_RealmNum and not ISyncDB[ISync_RealmNum] ) then ISyncDB[ISync_RealmNum] = { }; end


	-----------------------------------------------------

		for color, item, name in string.gfind(sText, "|c(%x+)|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h|r") do
		
			--make sure we have stuff to work with
			if( color and item and name ) then
		
				--get correct ItemID minus enchantments
				sParseLink = string.gsub(item, "^(%d+):(%d+):(%d+):(%d+)$", "%1:0:%3:%4");
				
				--first check to see if we can get an iteminfo.  If not no worries we will add it anyways.
				local name_X, link_X, quality_X, minLevel_X, class_X, subclass_X, maxStack_X = GetItemInfo("item:"..item);
				
				--check if the name doesn't match
				if(name_X and name_X ~= name) then
					name_X = name; --use the one that was taken
				end
				
				
				---------------------------------------------
				--if we have the link and name and it's not stored already plus it's allowed by the filter then add it
				if (sParseLink and link_X and quality_X and name_X and not ISyncDB[ISync_RealmNum][name_X] and ISync:CheckFilter(quality_X) == 1) then

					--we do have something so lets check on the colors to add
					local fluxColor = ISync:CheckColor(color, quality_X, 1);

					----------------------------------
					--we don't need to check on CheckColor because we have the quality num already
					--the reason it's sent to CheckColor is to update any errors in the color pattern
					----------------------------------

					--add it
					ISync:SetData(name_X, "item", sParseLink);
					ISync:SetData(name_X, "quality", quality_X);


					--PARSE TOOLTIP FOR SEARCH OPTIONS
					if(ISync.ParseTooltip) then
						UIParent.TooltipButton = 1;
						ISyncTooltip:SetOwner(UIParent, "ANCHOR_BOTTOMRIGHT");
						ISyncTooltip:SetHyperlink(link_X);
						ISync:ParseTooltip(name_X, ISync_RealmNum, sParseLink);
						ISyncTooltip:Hide();
					end


				--if already have the item and it has a link and name and it passes the filter then update the link if it's different
				--basically this will update and INVALID ITEM TO A VALID ITEM!!
				elseif(sParseLink and link_X and quality_X and name_X and ISyncDB[ISync_RealmNum][name_X] and ISync:CheckFilter(quality_X) == 1) then
					
					--check itemid if it doesn't match then it's probally and invalid becoming a valid!
					if(ISync:GetData(name_X, "item")) then
					
						if(ISync:GetData(name_X, "item") ~= sParseLink) then
						
							--update it cause it doesn't match
							ISync:SetData(name_X, "item", sParseLink);
						end
					
					end
					
					
					--PARSE TOOLTIP FOR SEARCH OPTIONS
					if(ISync.ParseTooltip) then
						UIParent.TooltipButton = 1;
						ISyncTooltip:SetOwner(UIParent, "ANCHOR_BOTTOMRIGHT");
						ISyncTooltip:SetHyperlink(link_X);
						ISync:ParseTooltip(name_X, ISync_RealmNum, sParseLink);
						ISyncTooltip:Hide();
					end
					
				
				--this item is invalid beyond help lol
				else
				
					--this item is so incredibly invalid it's crazy
					--were going to add it anyways cause I feel like it ;)
					
					--first check we don't have it in storage already
					if (ISyncDB[ISync_RealmNum][name]) then return nil; end
					
					--we do have something so lets check on the colors to add
					--this will grab the corresponding quality number for the hex color
					local fluxColor = ISync:CheckColor(color, nil, 1);
					
					--make sure we got a return
					if(fluxColor and tonumber(fluxColor) and ISync:CheckFilter(tonumber(fluxColor)) == 1) then

						--add it
						ISync:SetData(name, "item", sParseLink);
						ISync:SetData(name, "quality", tonumber(fluxColor));
					
						if(sEvent == "CHAT") then
						
							ISync_MainFrame.TooltipButton = this:GetID();
							GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
							GameTooltip:SetHyperlink("item:"..sParseLink);
							GameTooltip:Hide();
						end
						
					elseif(ISync:CheckFilter(99) == 1 and ISync:CheckFilter(0) == 1) then
						--for some forsaken reason the checkcolor didn't add the unknown
						--so force it anyways
	
						--add it
						ISync:SetData(name, "item", sParseLink);
						ISync:SetData(name, "quality", 0);
						
						if(sEvent == "CHAT") then
						
							ISync_MainFrame.TooltipButton = this:GetID();
							GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
							GameTooltip:SetHyperlink("item:"..sParseLink);
							GameTooltip:Hide();
				
						end
						
						
					end



				end--end regular item parsing
				------------------------------------


				-------------------------------------------------
				--add the merchant stuff only if item already in database
				if(sParseLink and ISyncDB[ISync_RealmNum][name]) then

					--check vendor stuff
					if(sVendorPrice) then
						ISync:SetData(name, "vendor", sVendorPrice);
					end
					if(sVendorQty) then
						ISync:SetData(name, "vendorqty", sVendorQty);
					end

				end
				-------------------------------------------------


			end --if( color and item and name ) then
		
		end --end for loop
		
	-----------------------------------------------------

	

	--exit function
	return nil;

end



---------------------------------------------------
-- ISync:CheckFilter
---------------------------------------------------
function ISync:CheckFilter(sQuality)

	--check for quality
	if(not sQuality) then return nil; end
	
	--convert to number
	sQuality = tonumber(sQuality);
	
	--make sure we have options
	if(ISyncOpt and ISyncOpt.Filters) then
 
 
 		--make sure we watch for unknowns/other
 		if(sQuality ~= 99 and sQuality > -1 and sQuality < 6) then
 		
			if(ISyncOpt.Filters[sQuality] and tonumber(ISyncOpt.Filters[sQuality]) == 1) then return 1; else return nil;end
 		
 		elseif(sQuality == 99) then
 		
 			--this is to process items we are unfamilar with
 			if(ISyncOpt.Filters[99] and tonumber(ISyncOpt.Filters[99]) == 1) then return 1; else return nil; end
 			
 		else
 			return nil;
 		end
 		
 	else
 		return nil;
 	end

end



---------------------------------------------------
-- ISync:CleanDatabase
---------------------------------------------------
function ISync:CleanDatabase(sOpt)

	--recreate database
	if( not ISyncDB ) then ISyncDB = { }; end

	--check realm name
	if(not ISync_RealmNum) then ISync_RealmNum = ISyncCore_AddRealm(); end

	--check realm
	if(ISync_RealmNum and not ISyncDB[ISync_RealmNum] ) then ISyncDB[ISync_RealmNum] = { }; end


		--do the loop
		for index, value in ISyncDB[ISync_RealmNum] do
		
			--if we get a number return then get rid of it
			if(tonumber(index)) then 
			
				ISyncDB[ISync_RealmNum][index] = nil; 
			
			elseif( index == "") then
			
				ISyncDB[ISync_RealmNum][index] = nil; 
				
			else
			
			
				--grab the first number if present, this will determine if it's a text name or old itemid storage
				local sParseLink = string.gsub(index, "^(%d+):(%d+):(%d+):(%d+)$", "%1");
				
				------------------------------
				--only do this for the old format
				if(tonumber(sParseLink)) then
				
					local name_X, link_X, quality_X, minLevel_X, class_X, subclass_X, maxStack_X = GetItemInfo("item:"..index);

					if(name_X and link_X and not ISyncDB[ISync_RealmNum][name_X]) then


						--store it
						ISync:SetData(name_X, "item", sParseLink);
						ISync:SetData(name_X, "info", value);
						
						--delete the old one
						ISyncDB[ISync_RealmNum][index] = nil;


					elseif(not name_X or link_X) then
					
						--delete the invalid for now we don't want them
						ISyncDB[ISync_RealmNum][index] = nil;
						
					else

						--it exists but we already have it stored so it's a duplicate
						
						--delete the invalid for now we don't want them
						ISyncDB[ISync_RealmNum][index] = nil;

					end

				else
				
					--now check for the stupid incorrect database storage problem where some itemid's where being stored in the sellvalue and such
					local s1, s2, sParseInfo2 = string.find(value, "(.-)");

					if(sParseInfo2) then

						if( ISync:PatternCount(sParseInfo2) > 9) then
						
							local getItemID = ISync:GetData(index, "item");
							local getItemIDCHK = ISync:GetData(index, "idchk");
							
							--empty out value
							ISyncDB[ISync_RealmNum][index] = nil;
							
							--save item
							if(getItemID) then
								ISync:SetData(index, "item", getItemID);
							end
							
							--save chk
							if(getItemIDCHK) then
								ISync:SetData(index, "idchk", getItemIDCHK);
							end
							
							
							--now add something stupid just to have it available
							ISync:SetData(index, "price", 0);
							
						end

					end
				
				
					--well it's not one of the old DB entries so it's probally new
					local s1, s2, sParseInfo = string.find(value, "(.-)");
					
					--if we don't even have a linkid for this item then get rid of it
					if(not sParseInfo) then
						ISyncDB[ISync_RealmNum][index] = nil; --get rid of it
					end

				end
				------------------------------
				
				

				
				
				
			end
								

		end--for index, value in ISyncDB[ISync_RealmNum] do


	if(sOpt) then
		DEFAULT_CHAT_FRAME:AddMessage("|c00A2D96FItemSync: "..ISYNC_CLEAN_SUCCESS.."|r");
	end

end


--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------


---------------------------------------------------
-- ISync:OnChatParse
---------------------------------------------------
function ISync:OnChatParse()

	--check loot items and convert to colored text if in database
	if( event == "CHAT_MSG_LOOT" and arg1) then
	
		if(ISyncVarLoad == 1) then
			
			ISync:ProcessLinks(arg1, "CHAT", nil, nil);
			
			this:AddMessage(arg1, ChatTypeInfo["LOOT"].r, ChatTypeInfo["LOOT"].g, ChatTypeInfo["LOOT"].b, ChatTypeInfo["LOOT"].id);
			
			--return true so we avoid adding it to chat
			return 1;
		end

	else
		--process chat anyways
		ISync:ProcessLinks(arg1, "CHAT", nil, nil);
		
	end	
	
	--return a nil to pass the information to original chatframe
	return nil;
		
end



--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------
-- ISync:GetItemID
---------------------------------------------------
function ISync:GetItemID(sLink)
	
	--check for link first
	if(not sLink) then return nil; end
	
	local item, name;

	for item, name in string.gfind(sLink, "|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h") do
	
		if(item and ISync:PatternCount(item) > 2) then return string.gsub(item, "^(%d+):(%d+):(%d+):(%d+)$", "%1:0:%3:%4"); end

	end--end for
	
	
	--try another way "item:0:0:0:0"
	item = string.gsub(sLink, "item:(%d+):(%d+):(%d+):(%d+)$", "%1:0:%3:%4")
	if(item and ISync:PatternCount(item) > 2) then return item; end
	
	--try another way "0:0:0:0"
	item = string.gsub(sLink, "(%d+):(%d+):(%d+):(%d+)$", "%1:0:%3:%4")
	if(item and ISync:PatternCount(item) > 2) then return item; end
	
	--everything has failed so just ignore
	return nil;
	
end




---------------------------------------------------
-- ISync:CheckColor
---------------------------------------------------
function ISync:CheckColor(sStringColor, sNumQuality, sOpt)
	
	--it can be either or so lets make sure at least one is available
	if(not sStringColor and not sNumQuality) then return nil; end
	if(not ISyncOpt) then return nil; end
	if(not ISyncOpt.Colors) then return nil; end
	
	--convert
	sNumQuality = tonumber(sNumQuality);
	
	--check on both
	if(sStringColor and sNumQuality) then
	
		--compare colors and values
		if(ISyncOpt.Colors[sNumQuality] and ISyncOpt.Colors[sNumQuality] == sStringColor) then
		
			--returns
			if(not sOpt or sOpt == 1) then --return num
				return sNumQuality;
			else --return string
				return sStringColor;
			end
			
		elseif(ISyncOpt.Colors[sNumQuality] and ISyncOpt.Colors[sNumQuality] ~= sStringColor) then
			
			--update it
			ISyncOpt.Colors[sNumQuality] = sStringColor; --num to string
			ISyncOpt.Colors[sStringColor] = sNumQuality; --string to num
			
			--returns
			if(not sOpt or sOpt == 1) then --return num
				return sNumQuality;
			else --return string
				return sStringColor;
			end
			
		elseif(not ISyncOpt.Colors[sNumQuality]) then
			
			--add it
			ISyncOpt.Colors[sNumQuality] = sStringColor; --num to string
			ISyncOpt.Colors[sStringColor] = sNumQuality; --string to num

			--returns
			if(not sOpt or sOpt == 1) then --return num
				return sNumQuality;
			else --return string
				return sStringColor;
			end
			
		end
		
	
	--check on colored string only
	elseif(sStringColor) then
	
		if(ISyncOpt.Colors[sStringColor]) then
		
			--returns
			if(not sOpt or sOpt == 1) then --return num
				return ISyncOpt.Colors[sStringColor];
			else --return string
				return sStringColor;
			end
			
		else
			--it doesn't exist but somehow it's a color
			--so lets add it and place it as unknown
			ISyncOpt.Colors[sStringColor] = 0; --string to num
		
			--returns
			if(not sOpt or sOpt == 1) then --return num
				return ISyncOpt.Colors[sStringColor];
			else --return string
				return sStringColor;
			end
			
		end
	
	
	--check on quality num only
	elseif(sNumQuality) then
	
	
		if(ISyncOpt.Colors[sNumQuality]) then
		
			--returns
			if(not sOpt or sOpt == 1) then --return num
				return sNumQuality;
			else --return string
				return ISyncOpt.Colors[sNumQuality];
			end
			
		else
			--it doesn't exist but somehow it's a color
			--so lets add it and place it as unknown
			ISyncOpt.Colors[sNumQuality] = "ff9d9d9d"; --num to string
		
			--returns
			if(not sOpt or sOpt == 1) then --return num
				return sNumQuality;
			else --return string
				return ISyncOpt.Colors[sNumQuality];
			end
			
		end
		
	
	end
	
	
	--if all else fails return nil
	return nil;
	
end




---------------------------------------------------
-- ISync:SimpleColor
---------------------------------------------------
function ISync:SimpleColor(sNumQuality)

	sNumQuality = tonumber(sNumQuality);
	
	local QL_Colors = { "ff9d9d9d", "ffffffff", "ff1eff00", "ff0070dd", "ffa335ee", "ffff8000", "ffffcc9d"};
	
	local color = QL_Colors[sNumQuality + 1];
	
	
	return color;

end

	

---------------------------------------------------
-- ISync:PatternCount
---------------------------------------------------
function ISync:PatternCount(sMsg)

   if(not sMsg) then
      return;
   end

   local i = 0;
   local iCount = 0;
   
   while true do
   
         i = string.find(sMsg, ":", i+1)    -- find 'next' ":"
         if i == nil then break end
        iCount = iCount + 1;
   
   end
   
   return iCount;

end


---------------------------------------------------
-- ISync:NameFromLink
---------------------------------------------------
function ISync:NameFromLink(sLink)

	local item, name;
	
	--check for link first
	if(not sLink) then return nil; end
	
	
	for item, name in string.gfind(sLink, "|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h") do

		if(name) then return name; end

	end--end for
	
	
	--try a different way
        for name in string.gfind(link, "|c%x+|Hitem:%d+:%d+:%d+:%d+|h%[(.-)%]|h|r") do
        
                if(name) then return name; end
        end

	
	return nil;
	
end



--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------
-- ISync:InspectTarget
---------------------------------------------------
function ISync:InspectTarget(sTarget)

	--only do until this is available
	if(not ISyncCore_InvList) then return nil; end
	
	
	for index = 1, getn(ISyncCore_InvList), 1 do
	
		local link = GetInventoryItemLink(sTarget, ISyncCore_InvList[index].id);
		
		if( link ) then

			ISync:ProcessLinks(link, nil, nil, nil)
	
		end
		
	
	
	end
	
end


---------------------------------------------------
-- ISync:ScanInv
---------------------------------------------------
function ISync:ScanInv()

	local bagid, size, slotid, link;
	
	for bagid=0,NUM_BAG_FRAMES,1 do
	
		size = GetContainerNumSlots(bagid);
		
		if( size ) then
			for slotid = size, 1, -1 do
				
				--get the container link
				link = GetContainerItemLink(bagid, slotid);
				
				if( link ) then
				
					ISync:ProcessLinks(link, nil, nil, nil)
				end
			end
		end
	end
end



---------------------------------------------------
-- ISync:ScanBank
---------------------------------------------------
function ISync:ScanBank()

	local bagid, size, slotid, link;
	
	--Bank Container
	size = GetContainerNumSlots(BANK_CONTAINER);
	for slotid = size, 1, -1 do
		link = GetContainerItemLink(BANK_CONTAINER, slotid);
		
		if( link ) then
			ISync:ProcessLinks(link, nil, nil, nil)
		end
	end
	
	--Bank Bag Containers
	for bagid= NUM_BAG_SLOTS + 1, (NUM_BAG_SLOTS + NUM_BANKBAGSLOTS), 1 do
	
		size = GetContainerNumSlots(bagid);
		if( size ) then
			for slotid = size, 1, -1 do
				link = GetContainerItemLink(bagid, slotid);
				
				if( link ) then
				
					ISync:ProcessLinks(link, nil, nil, nil)
				end
			end
		end
	end
	
end


---------------------------------------------------
-- ISync:ScanAuction
---------------------------------------------------
function ISync:ScanAuction()
	local numBatchAuctions, totalAuctions = GetNumAuctionItems("list");
	local auctionid;
	local link;

	if( numBatchAuctions > 0 ) then
		for auctionid = 1, numBatchAuctions do
		
			link = GetAuctionItemLink("list", auctionid);
			
			if( link ) then
				ISync:ProcessLinks(link, nil, nil, nil)
				
			end
		end
	end
end




---------------------------------------------------
-- ISync:AddMoney
---------------------------------------------------
function ISync:AddMoney()
	 ISync_HookedMoney(); --call the old function

	--this grabs the money from a new function since patch 1.7 and returns it
	if(ISyncVarLoad == 1 and arg1 and not InRepairMode()) then ISync_Cost = arg1; end
	
end



---------------------------------------------------
-- ISync:OnTooltipShow
---------------------------------------------------
function ISync:OnTooltipShow()

	ISync_MoneyTooltip:Hide();

end



---------------------------------------------------
-- ISync:MerchantMoneyScan
---------------------------------------------------
function ISync:MerchantMoneyScan(frame)

	local costOfItem;

	GameTooltip:Hide();

	for bag=0,NUM_BAG_FRAMES do
		for slot=1,GetContainerNumSlots(bag) do

		    local link = GetContainerItemLink(bag, slot);

		    if (link and link ~= "") then

			--get the name of the link
			local sName = ISync:NameFromLink(link);

			if(sName) then
				
				--reset
				ISync_Cost = 0;
				costOfItem = 0;
				
				--we had to change it to gametooltip because that is what is processing the money
				GameTooltip:SetBagItem(bag, slot); --set the bag slot to grab tooltip
				
				--hide again
				GameTooltip:Hide();

				local texture, itemCount, locked, quality, readable = GetContainerItemInfo(bag, slot);


				if( itemCount and itemCount > 0 and tonumber(ISync_Cost)) then --anything divided by 1 is itself
					costOfItem = floor(ISync_Cost / itemCount);
				end


				if(costOfItem and costOfItem ~= 0 and tonumber(costOfItem)) then

					ISync:SetData(sName, "price", costOfItem);
					
				elseif(tonumber(costOfItem) and costOfItem < 1) then
				
					--it equals zero so lets put n for the nosellprice to show
					ISync:SetData(sName, "price", -1);
				else
					--do nothing it's some sort of error
				end
				
				
			end--if(sName) then


		    end



		end--for slot=1,GetContainerNumSlots(bag) do
	end--for bag=0,NUM_BAG_FRAMES do
	

end


---------------------------------------------------
-- ISync:VendorScan
---------------------------------------------------
function ISync:VendorScan()

	--only do if merchant window is opened
	if(not MerchantFrame:IsVisible()) then return nil; end
	
	local numMerchantItems = GetMerchantNumItems();
	local name, texture, price, quantity, numAvailable, isUsable;
	
	for i=1, MERCHANT_ITEMS_PER_PAGE, 1 do
		local index = (((MerchantFrame.page - 1) * MERCHANT_ITEMS_PER_PAGE) + i);

		if ( index <= numMerchantItems ) then
			name, texture, price, quantity, numAvailable, isUsable = GetMerchantItemInfo(index);
		
			--get the link for the item
			local link = GetMerchantItemLink(index)
			
			--if there is a link, quantity, and a price then set it to be stored with
			--vendor price and information
			if (link and quantity and price) then
			
				ISync:ProcessLinks(link, nil , price, quantity);
				
			--for some reason there isn't any so lets just add it anyways
			elseif (link) then
			
				ISync:ProcessLinks(link, nil, nil, nil);
			end
		
				
		
		end
		
		
	end
	

end


--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------
-- ISync:GetData
---------------------------------------------------
function ISync:GetData(sID, SDelimiter)

	--check for DB	
	if( not ISyncDB ) then return nil; end
	if( not ISync_RealmNum) then return nil; end
	if( not ISyncDB[ISync_RealmNum]) then return nil; end
	if( not ISyncDB[ISync_RealmNum][sID]) then return nil; end
	if( sID == "") then return nil; end
	
	--make sure we have values to work with
	if(not sID or not SDelimiter) then return nil; end
		
	------------check for old database
		if(tonumber(sID)) then return nil; end
			local sParseLink = string.gsub(sID, "^(%d+):(%d+):(%d+):(%d+)$", "%1");
		if(tonumber(sParseLink)) then return nil; end
	------------
	
	--CHECK ITEM LINK GRAB
	--first are we grabbing the itemid if we are then just send that
	if(SDelimiter == "item") then
	
		local s1, s2, sParseInfo = string.find(ISyncDB[ISync_RealmNum][sID], "(.-)");
		
		return sParseInfo;
		
	end
	
	
	--get info
	if(SDelimiter == "info") then
	
		local s1, s2, sParseInfo = string.find(ISyncDB[ISync_RealmNum][sID], "(.-)");
		
		return sParseInfo;
		
	end
	
	
	--check to see if they are requesting to see if an item was inserted by the user
	if(SDelimiter == "idchk") then
	
		local s1, s2, sParseInfo = string.find(ISyncDB[ISync_RealmNum][sID], "(.-)");
		
		return sParseInfo;
	
	end
	
	
	--otherwise grab the other information
	local s1, s2, sParseInfo = string.find(ISyncDB[ISync_RealmNum][sID], "(.-)");

	--make sure we have something to work with		
	if(not sParseInfo) then return nil; end

	
	--convert to lowercase just in case
	SDelimiter = string.lower(SDelimiter);
	
	if(SDelimiter == "quality") then SDelimiter = 1;
	elseif(SDelimiter == "price") then SDelimiter = 2;
	elseif(SDelimiter == "wl") then SDelimiter = 3;
	elseif(SDelimiter == "wt") then SDelimiter = 4;
	elseif(SDelimiter == "ts") then SDelimiter = 5;
	elseif(SDelimiter == "at") then SDelimiter = 6;
	elseif(SDelimiter == "st") then SDelimiter = 7;
	elseif(SDelimiter == "level") then SDelimiter = 8;
	elseif(SDelimiter == "vendor") then SDelimiter = 9;
	elseif(SDelimiter == "vendorqty") then SDelimiter = 10; 
	else return nil; end


	--from quality to level just do gsub
	if(SDelimiter > 0 and SDelimiter < 9) then
	
		local dataGrab = string.gsub(sParseInfo, "^(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-)$", "%"..SDelimiter);
		
		return dataGrab;
		
		
	--it's the vendor information that we have to do the old fashion way
	else
	
		local sArray = ISync:SplitData(sParseInfo, ":")

		if(sArray) then

			--do the loop to check for a spot
			for index, value in sArray do

				if(index == SDelimiter ) then

					return value;
				end

			end
			

		end--if(sArray) then
	
	
	end--if(SDelimiter > 0 and SDelimiter < 9) then

	
	return nil;

end
				
---------------------------------------------------
-- ISync:SetData
---------------------------------------------------
function ISync:SetData(sID, SDelimiter, sValue)

	--check the DB
	if( not ISyncDB ) then ISyncDB = { }; end
	if( not ISync_RealmNum) then ISync_RealmNum = ISyncCore_AddRealm(); end;
	if( ISync_RealmNum and not ISyncDB[ISync_RealmNum] ) then ISyncDB[ISync_RealmNum] = { }; end
	if( sID == "") then return nil; end

	--make sure we have options to work with
	if(not ISyncOpt) then ISyncOpt = { }; end
	if( not ISyncOpt.ItemCount_Valid) then ISyncOpt.ItemCount_Valid = 0; end

	--make sure we have values to work with
	if(not sID or not SDelimiter or not sValue) then return nil; end
	
	------------check for old database
		if(tonumber(sID)) then return nil; end
			local sParseLink = string.gsub(sID, "^(%d+):(%d+):(%d+):(%d+)$", "%1");
		if(tonumber(sParseLink)) then return nil; end
	------------
	
	--convert to lowercase just in case
	SDelimiter = string.lower(SDelimiter);
	
	
	--check for item
	if(SDelimiter == "item") then
		
		if(not ISyncDB[ISync_RealmNum][sID]) then
		
			ISyncDB[ISync_RealmNum][sID] = ""..sValue.."";
			--update item count
			ISyncOpt.ItemCount_Valid = ISyncOpt.ItemCount_Valid + 1;
		
		else
			--grab the info
			local s1, s2, sParseInfo = string.find(ISyncDB[ISync_RealmNum][sID], "(.-)");
		
			--if we have info then just replace it
			if(sParseInfo) then
				--replace the old string with the new
				ISyncDB[ISync_RealmNum][sID] = string.gsub(ISyncDB[ISync_RealmNum][sID], ""..sParseInfo.."", ""..sValue.."");
			
			else
				--it doesn't exist for some reason so lets add it
				ISyncDB[ISync_RealmNum][sID] = ISyncDB[ISync_RealmNum][sID]..""..sValue.."";
				
				ISyncOpt.ItemCount_Valid = ISyncOpt.ItemCount_Valid + 1;
			end
			
		
		end--if(not ISyncDB[ISync_RealmNum][sID]) then
		
		
		--update the display frame if shown
		if(ISyncOpt and ISyncOpt.ItemDisplay and ISync.ItemDisplay_Update) then
			ISync:ItemDisplay_Update();
		end
		
	
		return nil; --exit
		
			
	end--if(SDelimiter == "item") then
	
	
	--check for item
	if(SDelimiter == "info") then
		
		if(not ISyncDB[ISync_RealmNum][sID]) then
		
			ISyncDB[ISync_RealmNum][sID] = ""..sValue.."";

		else
			--grab the info
			local s1, s2, sParseInfo = string.find(ISyncDB[ISync_RealmNum][sID], "(.-)");
		
			--if we have info then just replace it
			if(sParseInfo) then
				--replace the old string with the new
				ISyncDB[ISync_RealmNum][sID] = string.gsub(ISyncDB[ISync_RealmNum][sID], ""..sParseInfo.."", ""..sValue.."");
			
			else
				--it doesn't exist for some reason so lets add it
				ISyncDB[ISync_RealmNum][sID] = ISyncDB[ISync_RealmNum][sID]..""..sValue.."";
				
			end
			
		
		end--if(not ISyncDB[ISync_RealmNum][sID]) then
		

		return nil; --exit
		
			
	end--if(SDelimiter == "item") then
	
	
	--check to see if they are requesting to see if an item was inserted by the user
	if(SDelimiter == "idchk") then
	
		if(not ISyncDB[ISync_RealmNum][sID]) then
		
			ISyncDB[ISync_RealmNum][sID] = ""..sValue.."";

		else
			--grab the info
			local s1, s2, sParseInfo = string.find(ISyncDB[ISync_RealmNum][sID], "(.-)");
		
			--if we have info then just replace it
			if(sParseInfo) then
				--replace the old string with the new
				ISyncDB[ISync_RealmNum][sID] = string.gsub(ISyncDB[ISync_RealmNum][sID], ""..sParseInfo.."", ""..sValue.."");
			
			else
				--it doesn't exist for some reason so lets add it
				ISyncDB[ISync_RealmNum][sID] = ISyncDB[ISync_RealmNum][sID]..""..sValue.."";
				
			end
			
		
		end--if(not ISyncDB[ISync_RealmNum][sID]) then
		

		return nil; --exit
	
	end
	
	
	
	if(SDelimiter == "quality") then SDelimiter = 1;
	elseif(SDelimiter == "price") then SDelimiter = 2;
	elseif(SDelimiter == "wl") then SDelimiter = 3;
	elseif(SDelimiter == "wt") then SDelimiter = 4;
	elseif(SDelimiter == "ts") then SDelimiter = 5;
	elseif(SDelimiter == "at") then SDelimiter = 6;
	elseif(SDelimiter == "st") then SDelimiter = 7;
	elseif(SDelimiter == "level") then SDelimiter = 8;
	elseif(SDelimiter == "vendor") then SDelimiter = 9;
	elseif(SDelimiter == "vendorqty") then SDelimiter = 10;
	else return nil; end

	sValue = tonumber(sValue);

	--make sure we have a number from here on
	if(not sValue) then return nil; end
	if(not tonumber(sValue)) then return nil; end

	--------------------------------------------
	--double check that we want to add this sucker because of the filter
	if(SDelimiter == 1 and ISync:CheckFilter(sValue) ~= 1) then
	
		--delete it if it exists
		if(ISyncDB[ISync_RealmNum][sID]) then
			ISyncDB[ISync_RealmNum][sID] = nil;
		end
		
		--ignore the rest
		return nil;
		
	end
	--------------------------------------------

	
	local sDBString, index;
	local s1, s2, sParseInfo;
	
	--check to see if it exists
	if(not ISyncDB[ISync_RealmNum][sID]) then

		ISyncDB[ISync_RealmNum][sID] = "0:0:0:0:0:0:0:0:0:0";

		sParseInfo = "0:0:0:0:0:0:0:0:0:0";
		
	else

		--grab the regular data
		s1, s2, sParseInfo = string.find(ISyncDB[ISync_RealmNum][sID], "(.-)");

		--if we don't have it then add it as zero
		if(not sParseInfo) then

			ISyncDB[ISync_RealmNum][sID] = ISyncDB[ISync_RealmNum][sID].."0:0:0:0:0:0:0:0:0:0";

			sParseInfo = "0:0:0:0:0:0:0:0:0:0";
		end
	
	
	end
	

		
		--grab the info array
		local sArray = ISync:SplitData(sParseInfo, ":")

		if(sArray) then
		
			--do the loop to check for a spot
			for index, value in sArray do

				if(index == 1 and index == SDelimiter ) then

					sDBString = sValue;

				--it isn't the one were looking for but don't add a trailing colon
				elseif(index == 1 and index ~= SDelimiter) then

					sDBString = value;

				elseif(index ~= 1 and index == SDelimiter) then

					sDBString = sDBString..":"..sValue;

				else

					sDBString = sDBString..":"..value;
				end

			end
		
			--store it
			ISyncDB[ISync_RealmNum][sID] = string.gsub(ISyncDB[ISync_RealmNum][sID], ""..sParseInfo.."", ""..sDBString.."");
			
			
		end--if(sArray) then
		
		

	

	--update the display frame if shown
	if(ISyncOpt and ISyncOpt.ItemDisplay and ISync.ItemDisplay_Update) then
		ISync:ItemDisplay_Update();
	end
	
	
	--reset some stuff
	sArray = nil;
	s1, s2, sParseInfo = nil;
	sDBString, index = nil;
	
	
	
	return nil;

end

---------------------------------------------------
-- ISync:SplitData
---------------------------------------------------
function ISync:SplitData(sData, sDelimiter)

	--first check for data
	if(not sData) then return nil; end
	
	--now check for a delimiter
	if(not sDelimiter) then return nil; end
	
	--make sure the data is a string
	if (type(sData) ~= "string") then return nil; end
	
	--declare
	local sTemp, xMaker, yMarker = {},0
	
	--start loop
	while(xMaker) do
		
		--look for marker position
		xMaker, yMarker = strfind(sData, sDelimiter)
	
		--if a marker then add to table
		if(xMaker) then
		
			--load into tables
		    	tinsert(sTemp, tonumber(strsub(sData, 1, xMaker - 1 )))
		    
		    	--update data
		    	sData = strsub(sData, yMarker + 1)
		    
		else
			--continue the insertion
			--with the entire data in the first array of the table
		    	tinsert(sTemp, tonumber(sData))
		    	break;
		end


	end--end while loop
	
    
    
    return sTemp; --return array

end

--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
